<template>
    <div class="root">
          <h2 class="logo">Personal Settings</h2>
        <p>
        These settings will be used in the boilerplates.
        </p>
        <div class="inputs">
          <div class="form-group">
            <input v-model="name" type="text" class="form-control" id="name" placeholder="Your Name">
          </div>
          <div class="form-group">
            <input v-model="email" type="email" class="form-control" id="email" placeholder="Your Email">
          </div>
          <div class="form-group">
            <input v-model="homepage" type="text" class="form-control" id="email" placeholder="Homepage">
          </div>
          <div class="form-group">
            <input v-model="projectName" type="text" class="form-control" id="projectName" placeholder="Project Name">
          </div>
        </div>
        <div class="buttons">
          <button class="btn btn-success" @click="save">Save</button>
          <button class="btn btn-default" @click="abort">Cancel</button>
        </div>
    </div>
</template>

<script>
import { setHtmlTags } from '../utils'
import * as types from '../store/mutation-types'

export default {
  computed: {
    name: {
      get () {
        return this.$store.state.preferences.name
      },
      set (value) {
        this.$store.commit(types.SET_PREFS_NAME, value)
      }
    },
    email: {
      get () {
        return this.$store.state.preferences.email
      },
      set (value) {
        this.$store.commit(types.SET_PREFS_EMAIL, value)
      }
    },
    homepage: {
      get () {
        return this.$store.state.preferences.homepage
      },
      set (value) {
        this.$store.commit(types.SET_PREFS_HOMEPAGE, value)
      }
    },
    projectName: {
      get () {
        return this.$store.state.preferences.projectName
      },
      set (value) {
        this.$store.commit(types.SET_PREFS_PROJECT_NAME, value)
      }
    }
  },
  mounted: function () {
    const description = 'Personal settings which are used in the generated boilerplates.'
    setHtmlTags('Personal Settings - python-boilerplate.com', description)
  },
  methods: {
    save (e) {
      this.$store.dispatch('savePreferences')
    },
    abort (e) {
      this.$store.dispatch('loadPreferences')
      this.$router.go(-1)
    }
  }
}
</script>

<style scoped>
.root {
  padding-left: 40px;
  max-width: 600px;
}

h2.logo {
  margin-top: 30px;
}

.inputs {
  margin-top: 22px;
  max-width: 340px;
}

.buttons {
  margin-top: 22px;
}
</style>
